CON

_CLKMODE = XTAL1 + PLL16X
_XINFREQ = 5_000_000

OBJ

DBG            : "FullDuplexSerialPlus"   
F              : "FloatMath"
FS             : "FloatString"
 

VAR

LONG   tenf[86]



PUB Main | oK, resStr
'Does some test calculations

'Start FullDuplexSerialPlus Driver for debug
oK := DBG.Start(31, 30, 0, 57600)

WAITCNT(CLKFREQ * 6 + CNT)

IF oK
  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("String To Float Test started..."))

  S2FInit

  WAITCNT(CLKFREQ + CNT)

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Converting '1.2E3' ...", 10, 13, 13))
  resStr := FS.FloatToString(StringToFloat(STRING("1.2E3")))
  DBG.Str(STRING("Result as float:")) 
  DBG.Str(resStr)
  WaitKeyPress

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Converting '-1.234E5' ...", 10, 13, 13))
  resStr := FS.FloatToString(StringToFloat(STRING("-1.234E5")))
  DBG.Str(STRING("Result as float:")) 
  DBG.Str(resStr)
  WaitKeyPress 

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Converting '1.2345E-6' ...", 10, 13, 13))
  resStr := FS.FloatToString(StringToFloat(STRING("1.2345E-6")))
  DBG.Str(STRING("Result as float:")) 
  DBG.Str(resStr)    
  WaitKeyPress

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Converting '-1.23456E+7' ...", 10, 13, 13))
  resStr := FS.FloatToString(StringToFloat(STRING("-1.23456E+7")))
  DBG.Str(STRING("Result as float:")) 
  DBG.Str(resStr)    
  WaitKeyPress

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Converting '1.234567E-8' ...", 10, 13, 13))
  resStr := FS.FloatToString(StringToFloat(STRING("1.234567E-8")))
  DBG.Str(STRING("Result as float:")) 
  DBG.Str(resStr)    
  WaitKeyPress

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Converting '1.234567E38' ...", 10, 13, 13))
  resStr := FS.FloatToString(StringToFloat(STRING("1.234567E38")))
  DBG.Str(STRING("Result as float:")) 
  DBG.Str(resStr)    
  WaitKeyPress

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Converting '1.234567e-32' ...", 10, 13, 13))
  resStr := FS.FloatToString(StringToFloat(STRING("1.234567e-32")))
  DBG.Str(STRING("Result as float:")) 
  DBG.Str(resStr)    
  WaitKeyPress

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Converting '1.234567e-37' ...", 10, 13, 13))
  resStr := FS.FloatToString(StringToFloat(STRING("1.234567e-37")))
  DBG.Str(STRING("Result as float:")) 
  DBG.Str(resStr)    
  WaitKeyPress              

  DBG.Str(STRING(16, 1))
  DBG.Str(STRING("Program finished...", 10, 13, 13))
  WAITCNT(CLKFREQ + CNT)
  DBG.Stop
  

PUB StringToFloat(strptr) : flt | significand, ssign, places, exp, esign 
{{
  Converts string to floating-point number
  entry:
      strptr = pointer to z-string

  exit:
      flt = floating-point number


  Assumes the following floating-point syntax: [-] [0-9]* [ . [0-9]* ] [ e|E [-|+] [0-9]* ]
                                               +-- +----- +----------- +-------------------
                                                                         +---- +-----
    Optional negative sign --------------------+                               
    Digits ----------------------------------------+                            
    Optional decimal point followed by digits ------------+                      
    Optional exponent -------------------------------------------------+          
      optional exponent sign ------------------------------------------------+     
      exponent digits -------------------------------------------------------------+

  Examples of recognized floating-point numbers:
  "123", "-123", "123.456", "123.456e+09"
  
  Conversion stops as soon as an invalid character is encountered. No error-checking.
    
  Based on Ariba's StrToFloat in http://forums.parallax.com/forums/default.aspx?f=25&m=280607
}}
  significand~
  ssign~
  exp~
  esign~
  places~
  repeat
    case byte[strptr]
      "-":
        ssign~~
      ".":
        places := 1
      "0".."9":
        significand := significand * 10 + byte[strptr] - "0"
        if places
          ++places                    'count decimal places
      "e", "E":
        ++strptr ' skip over the e or E
        repeat
          case byte[strptr]
            "+":
              ' ignore
            "-":
              esign~~
            "0".."9":
              exp := exp * 10 + byte[strptr] - "0"
            other:
              quit
          ++strptr
        quit              
      other:
        quit
    ++strptr


  DBG.Str(STRING("      ssign:"))  
  DBG.Dec(ssign)
  DBG.Str(STRING(10, 13))

  DBG.Str(STRING("significand:"))  
  DBG.Dec(significand)
  DBG.Str(STRING(10, 13))

  DBG.Str(STRING("        exp:"))  
  DBG.Dec(exp)
  DBG.Str(STRING(10, 13))

  DBG.Str(STRING("      esign:"))  
  DBG.Dec(esign)
  DBG.Str(STRING(10, 13))

  DBG.Str(STRING("     places:"))  
  DBG.Dec(places)
  DBG.Str(STRING(10, 13))
    
  if ssign
    -significand
  flt := f.FFloat(significand)

  ifnot esign  ' tenf table is in decreasing order, so the sign of exp is reversed
    -exp
    
  if places
    exp += places - 1
        
  flt := f.FMul(flt, tenf[exp+38])              'adjust flt's decimal point


  DBG.Str(STRING(" tenf index:"))  
  DBG.Dec(exp)
  DBG.Str(STRING(10, 13, 13))

  

PRI S2FInit | i
'Fills tenf array

tenf[0] := 1E+38                  
REPEAT i From 1 TO 85
  tenf[i] := f.FDIV(tenf[i-1],10.0)
'But this did not work well below e-32   

  

PRI WaitKeyPress | kB
'Waits for a keypress

DBG.Str(STRING(10, 13, 13))
DBG.Str(STRING("Press any key to continue..."))
REPEAT
  kB := DBG.Rxcheck
  IF kB > -1
    QUIT

